#pragma once

#include <string>
#include <sstream>
#include <iostream>
#include <list>
#include "TransformElement.h"
#include "Transform.h"


/**
* \IuWFNg̊NX
* 
*/
class DrawnObject{
public:
	DrawnObject(std::string name);
	virtual ~DrawnObject(void);

	virtual void Draw(void) = 0;	//!< `惁\bh

	virtual void Dump(void) = 0;	//!< IuWFNg̓^[~iփ_v
	virtual void Dump(int depth,std::stringstream &ret) = 0;	//!< IuWFNg̓𕶎փ_v
	
	void SetIsDisplay(bool f);	//!< IuWFNg\/\ݒ
	bool GetIsDisplay(void);	//!< IuWFNg̕\[h擾

	void SetName(std::string name);	//!< ʖZbg
	std::string GetName(void);		//!< ʖ擾

	Transform *transform;	//!< `挴_ւ̍Wϊo^
protected:
	std::string name;	//!< ̃IuWFNg̎ʖ
	bool isDisplay;		//!< trueŕ\
};
