#pragma once
#include "TransformElement.h"
#include <string>
#include <GL/glut.h>
#include <sstream>
#include "MyUtility.h"
#include "RangedDouble.h"
class RotateTransform :public TransformElement{
public:
	enum AXIS{
		UNDEFINE,X,Y,Z
	};
	RotateTransform(std::string name);
	RotateTransform(AXIS axis,std::string name);
	RotateTransform(AXIS axis,double theta,std::string name);
	
	
	~RotateTransform(void);
	void Dump(void);
	void Dump(std::stringstream &ret);
	void Dump(int depth,std::stringstream &ret);
	void Apply(void);
	void SetValue();
	void SetValue(double theta);
	void Draw(void);
	void Draw(double r);
	
	void GetValue(void);
	void GetValue(double *retVal);
	char GetAxisNameFromEnum(RotateTransform::AXIS axis);
	RangedDouble *theta;
private:
	//double theta;
	AXIS axis;
	double r;	//Wn\p
};
