#pragma once
#include "TransformElement.h"
#include <string>
#include <GL/glut.h>
#include <sstream>
#include <iostream>
#include "MyUtility.h"
#include "RangedDouble.h"

class TranslateTransform:public TransformElement{
public:
	TranslateTransform(std::string name);
	TranslateTransform(double x,double y,double z,std::string name);
	void Dump(void);
	void Dump(std::stringstream &ret);
	void Dump(int depth,std::stringstream &ret);

	void Apply(void);
	void SetValue(double x,double y,double z);
	void Draw(void);
	void GetValue(double retVal[3]);
	~TranslateTransform();

	//double delta[3];
	RangedDouble *delta[3];
};

