#include "CoordinateSystemView.h"
#include <GL/glut.h>

CoordinateSystemView::CoordinateSystemView(double scale){
	this->scale = scale;
	this->isDisplay = true;
}

CoordinateSystemView::~CoordinateSystemView(void){
}


void CoordinateSystemView::SetIsDisplay(bool f){
	this->isDisplay = f;
}
bool CoordinateSystemView::GetIsDisplay(void){
	return this->isDisplay;
}

void CoordinateSystemView::Draw(double scale){
	double temp;
	temp = this->scale;
	this->scale = scale;
	this->Draw();
	this->scale = temp;
}

/**
* Wn`悷
* 
*/
void CoordinateSystemView::Draw(void){
	if(this->isDisplay){
		glDisable(GL_LIGHTING);

		glColor3d(1,0,0);
		glBegin(GL_LINES);
		glVertex3d(0,0,0);
		glVertex3d(this->scale,0,0);
		glEnd();


		glColor3d(0,1,0);
		glBegin(GL_LINES);
		glVertex3d(0,0,0);
		glVertex3d(0,this->scale,0);
		glEnd();


		glColor3d(0,0,1);
		glBegin(GL_LINES);
		glVertex3d(0,0,0);
		glVertex3d(0,0,this->scale);
		glEnd();
	
		glEnable(GL_LIGHTING);
	}
}