#pragma once
#include "DrawnObject.h"
#include "Triangle.h"
#include <list>
#include <string>
#include <vector>
#include <GL/glut.h>
#define _CRT_SECURE_NO_DEPRECATE
/**
* STLt@C琶IuWFNg
*
*/
class DrawnObjectBySTL :	public DrawnObject{
typedef  std::vector<Triangle*> TriangleList;

public:
	DrawnObjectBySTL(std::string name);
	DrawnObjectBySTL(GLfloat r,GLfloat g,GLfloat  b,std::string name);
	~DrawnObjectBySTL(void);
	void Dump(void);
	void Dump(int depth,std::stringstream &ret);
	void Draw(void);
	bool Load(std::string sourceFileName);
	void ResisterTriangleList();

	void SetColor(double r,double g,double b);
	const float* GetColor(void);
private:
	TriangleList triangles;
	bool isSingleColorEnable;
	GLfloat singleColor[3];

	std::string filePath;

};
