#ifndef TRANSFROM_ELEMENT_H
#define TRANSFROM_ELEMENT_H

#include <string>
#include <sstream>
#include <list>


/**
*	WϊNX̊NX
*	
*/
class TransformElement{
public:
	typedef std::list<TransformElement*> TransformElementList; 

	TransformElement(std::string name);	//RXgN^
	virtual ~TransformElement();	//zfXgN^

	virtual void Dump(void) = 0;
	virtual void Dump(std::stringstream &ret) = 0;
	virtual void Dump(int depth,std::stringstream &ret) = 0;
	virtual void Apply(void) = 0;
	virtual void Draw(void)=0;

	//ANZT
	void SetIsEnable(bool enable);
	bool GetIsEnable(void);

	void SetIsNegative(bool neg);
	bool GetIsNegative(void);

	std::string GetName(void);
	void SetName(std::string name);

protected:
	std::string name;
	bool isEnable;
	bool isDisplay;
	bool isNegative;
};


#endif